/*
 *	main.c
 *
 *	ʂ
 *	Copyright (C) 2001-2002 Naoyuki Sawa
 *
 *	* Mon Jun  3 05:34:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

static void app_init();
static void app_exit();

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	int retval;

	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		retval = demo();
		if(retval == 0) break;

		game();
	}

	/* N[AbvB */
	app_exit();

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

static void
app_init()
{
	int retval;
	char* data;
	FILEACC fa;

	/* ʓIȏB */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceAppSetProcPeriod(1000 / FPS);
	pcePadSetTrigMode(PP_MODE_SINGLE); /* I[gs[gȂ */
	pceLCDDispStart();

	/* T[tFCXB */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	surface.zbuff = NULL; /* Zobt@Ȃ */

	/* _[B */
	render_init(&render, &surface, 0, 0, 0, 0, 0, 0, 0);

	/* eNX`B */
	retval = pceFileOpen(&fa, TEXTURE_FNAME, FOMD_RD);
	if(retval != 0) DIE();
	data = (char*)pceHeapAlloc(fa.fsize); /* ̗̈͊J܂ */
	if(data == NULL) DIE();
	retval = file_read(&fa, data, 0, fa.fsize);
	if(retval != fa.fsize) DIE();
	pceFileClose(&fa);
	texture_init(&texture, data);
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

static void
app_exit()
{
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
	pceLCDTrans();

	/*----------*/ yield(); /*----------*/

	now++;
	pad = pcePadGet();
}
