/*	
 *	clippce.c
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2002 Naoyuki Sawa
 *
 *	* Wed Apr 24 09:26:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 *	* Sun Jun  2 04:45:00 JST 2002 Naoyuki Sawa
 *	- pceAppInit()ōpceLCDDrawObjectCXg[A
 *	  pceAppExit()ōpceLCDDrawObjectACXg[悤ɂ܂B
 *	  AAvP[Vł̍ƂsKv͂܂B
 *	* Sun Jun  2 20:07:00 JST 2002 Naoyuki Sawa
 *	- pceLCDDrawObject()clipdobj.cɕB
 */
#include "clip.h"
#include "clipdobj.c" /* pceLCDDrawObject */

/*****************************************************************************
 *	O[oϐ
 *****************************************************************************/

/* S1C33 Family CRpCpbP[Wł́Aerrno̓AvP[VŒ`Kv܂B
 * [S5U1C33000C_J.pdf p.140]
 */
int errno;

/*****************************************************************************
 *	[Jϐ
 *****************************************************************************/

/* vOIɎs֐ւ̃|C^B
 * atexit()œo^܂B(݂̎ł͈x݂̂łB)
 * NULLȂA܂o^Ă܂B
 */
static void (*exit_func)();
static char heap[0x2000];	/* malloc()pq[v̈(8KB) */

/*****************************************************************************
 *	P/ECEpE[maint[[N
 *****************************************************************************/

static void app_proc();
static void app_exit();

/* * ėpWX^̂AۑKv̂́Ar0`r3݂̂łB
 *   [S5U1C33000C_J.pdf p.84]
 */
typedef struct _CONTEXT {
	int r0, r1, r2, r3;
	int* sp;
} CONTEXT;
/* * system_contextuser_context́AstaticϐƂĂ̂łA
 *   CRpĆAasmubNŕϐ삵Ă邱Ƃ𔻒fłA
 *   "system_context`Ă邪AgĂȂ"ƌx܂B
 *   ́Ax}̂߂ɁAO[oϐƂ邱Ƃɂ܂B
 */
CONTEXT system_context;	/* VXeReLXgۑp */
CONTEXT user_context;	/* [U[ReLXgۑp */

void
pceAppInit()
{
	/* [U[ReLXg܂B */
	user_context.sp = (int*)0x1C00;		/* 1000`1C00:[U[X^bN(3KB) */
						/* 1C00`2000:VXeX^bN(1KB) */
	*--user_context.sp = (int)app_exit;	/* main()ԂɌĂ΂֐ */
	*--user_context.sp = (int)main;		/* AvP[V`Gg|Cg */

	/* malloc()pq[v̈܂B */
	ansi_InitMalloc((int)heap, (int)heap + sizeof heap);

	/* pceLCDDrawObjectCXg[܂B */
	hook_LCDDrawObject();
}

void
pceAppProc(int count)
{
	/* yield()ƃX^bNt[̍\킹Kv̂ŁA
	 * Ȃ̊֐oR܂B
	 */
	app_proc();
}

void
pceAppExit()
{
	/* atexit()œo^ꂽIԐ΁AĂяo܂B */
	if(exit_func != NULL) exit_func();

	/* pceLCDDrawObjectACXg[܂B */
	unhook_LCDDrawObject();
}

void
app_proc()
{
	asm("
	; VXeReLXgޔ܂B
	xld.w %r7, system_context
	ld.w [%r7]+, %r0
	ld.w [%r7]+, %r1
	ld.w [%r7]+, %r2
	ld.w [%r7]+, %r3
	ld.w %r4, %sp
	ld.w [%r7]+, %r4

	; [U[ReLXg𕜌܂B
	xld.w %r7, user_context
	ld.w %r0, [%r7]+
	ld.w %r1, [%r7]+
	ld.w %r2, [%r7]+
	ld.w %r3, [%r7]+
	ld.w %r4, [%r7]+
	ld.w %sp, %r4
	");
}

static void
app_exit()
{
	asm("
	; VXeReLXg𕜌܂B
	xld.w %r7, system_context
	ld.w %r0, [%r7]+
	ld.w %r1, [%r7]+
	ld.w %r2, [%r7]+
	ld.w %r3, [%r7]+
	ld.w %r4, [%r7]+
	ld.w %sp, %r4

	; Iv𔭍s܂B
	ld.w %r12, %r10
	xcall pceAppReqExit
	");
}

void
yield()
{
	asm("
	; [U[ReLXgޔ܂B
	xld.w %r7, user_context
	ld.w [%r7]+, %r0
	ld.w [%r7]+, %r1
	ld.w [%r7]+, %r2
	ld.w [%r7]+, %r3
	ld.w %r4, %sp
	ld.w [%r7]+, %r4

	; VXeReLXg𕜌܂B
	xld.w %r7, system_context
	ld.w %r0, [%r7]+
	ld.w %r1, [%r7]+
	ld.w %r2, [%r7]+
	ld.w %r3, [%r7]+
	ld.w %r4, [%r7]+
	ld.w %sp, %r4
	");
}

int
atexit(void (*func )())
{
	/* ݂̎ł́Axڂ͎s܂B */
	if(exit_func != NULL) return -1;

	/* ֐|C^i[܂B */
	exit_func = func;

	return 0;
}

/*****************************************************************************
 *	̑̃[eBeB֐
 *****************************************************************************/

#define BLOCKSIZE 4096 /* P/ECEtbVt@CVXẽZN^TCY */

int
file_read(FILEACC* fa, void* ptr, int ofs, int len)
{
	int i, sct, sof, sln;
	char* p = (char*)ptr;

	i = 0;
	while(i < len) {
		/* ZN^̃tbVAhX擾܂B */
		sct = (ofs + i) / BLOCKSIZE;			/* sct = ݂̓ǂݍ݃ItZbg܂ރZN^ԍ                         */
		sln = pceFileReadSct(fa, NULL, sct, BLOCKSIZE);	/* sln = ̃ZN^̃f[^TCY(ŏIZN^̂sln<=BLOCKSIZEɂȂ܂) */
		if(sln == 0) break;				/* ԂItZbg                                                   */

		/* ̃ZN^ǂݍރTCY肵܂B */
		sof = (ofs + i) % BLOCKSIZE;			/* ZN^ItZbg                                                       */
		sln -= sof;					/* ZN^ItZbgȍ~ǂݍ݉\ȍőf[^TCY                 */
		if(sln > len - i) sln = len - i;		/* ǂݍ݉\ȍőf[^TCYcǂݍ݃TCYȏȂA؂l߂܂ */
		if(sln <= 0) break;				/* ԂItZbg߁A܂͓ǂݍ݃TCY0ȉw肳ꂽ(len<=0)    */

		/* ZN^obt@֓ǂݍ݂܂B */
		memcpy(p + i, fa->aptr + sof, sln);
		i += sln;
	}

	return i;
}

int
file_write(FILEACC* fa, const void* ptr, int ofs, int len)
{
	int i, sct, sof, sln;
	char* buf;
	const char* p = (const char*)ptr;

	/* v1.18݂P/ECEJ[ĺApceFileOpen()Ɏw肳ꂽmode𖳎܂B
	 *   FOMD_RDŊJt@Cɑ΂ĂpceFileWriteSct()ł܂A
	 *   FOMD_WRŊJt@Cɑ΂ĂpceFileReadSct()ł܂B
	 *   file_write()֐ɓnt@ĆAFOMD_WRŊJĂ͂łA
	 *   L̓𗘗pāApceFileReadSct()gĂ܂Ă܂B
	 */

	/* ZN^̈ꕔ邽߂ɁAZN^ŜRAMɓǂݍރobt@mۂ܂B */
	buf = pceHeapAlloc(BLOCKSIZE);
	if(buf == NULL) return 0;

	i = 0;
	while(i < len) {
		/* ZN^̃tbVAhX擾܂B */
		sct = (ofs + i) / BLOCKSIZE;			/* sct = ݂̏݃ItZbg܂ރZN^ԍ                             */
		sln = pceFileReadSct(fa, buf, sct, BLOCKSIZE);	/* ̃ZN^̑Sf[^擾܂B(ŏIZN^̂sln<=BLOCKSIZEɂȂ܂) */
		if(sln == 0) break;				/* ԂItZbg                                                       */

		/* ̃ZN^ɏރTCY肵܂B */
		sof = (ofs + i) % BLOCKSIZE;			/* ZN^ItZbg                                                       */
		sln -= sof;					/* ZN^ItZbgȍ~ɏ݉\ȍőf[^TCY                   */
		if(sln > len - i) sln = len - i;		/* ݉\ȍőf[^TCYc菑݃TCYȏȂA؂l߂܂ */
		if(sln <= 0) break;				/* ԂItZbg߁A܂͏݃TCY0ȉw肳ꂽ(len<=0)    */

		/* ZN^̑Sf[^̈ꕔ܂B */
		memcpy(buf + sof, p + i, sln);
		i += sln;

		/* ZN^̑Sf[^tbVɏ߂܂B */
		pceFileWriteSct(fa, buf, sct, BLOCKSIZE);	/* ŏIZN^̖ߕ́ApceFileWriteSct()ɂĐ؂l߂܂  */
								/* Ŏs邱Ƃ͂肦Ȃ͂Ȃ̂ŁAG[`FbN͍s܂ */
	}

	/* obt@J܂B */
	pceHeapFree(buf);

	return i;
}

void
draw_object(PIECE_BMP* src, int dx, int dy, int sx, int sy, int w, int h, int param)
{
	DRAW_OBJECT obj;

	pceLCDSetObject(&obj, src, dx, dy, sx, sy, w, h, param);
	pceLCDDrawObject(obj);
}

