/*
 *	data.c
 *
 *	ʂ
 *	Copyright (C) 2001-2002 Naoyuki Sawa
 *
 *	* Tue Jun  4 05:23:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

/****************************************************************************
 *	LN^`
 ****************************************************************************/

CHR chrs[N_CHRS] = {
#define CHRDEF
#include "nuwangi.h"
#undef CHRDEF
};

/****************************************************************************
 *	LN^S`
 ****************************************************************************/

CNT cnts[N_CHRS] = {
	/******** kM ********/
	/*  */
	{  9, 25 }, /*  0: 0    */
	{  9, 25 }, /*  1: 1    */
	{  9, 25 }, /*  2: 2    */
	{ 16, 23 }, /*  3: _[W */
	{  8, 25 }, /*  4: 0    */
	{  8, 25 }, /*  5: 1    */
	{  9, 25 }, /*  6: 2    */
	{ 14, 26 }, /*  7: UA0   */
	{ 19, 23 }, /*  8: UA1   */
	{  7, 47 }, /*  9: UA2   */
	{ 13, 46 }, /* 10: UA3   */
	{ 13, 46 }, /* 11: UA4   */
	{  9, 24 }, /* 12: UB0   */
	{  9, 21 }, /* 13: UB1   */
	{ 31, 25 }, /* 14: UB2   */
	{ 29, 26 }, /* 15: UB3   */
	{ 29, 26 }, /* 16: UB4   */
	/* w */
	{ 11, 27 }, /*  0: 0    */
	{ 11, 27 }, /*  1: 1    */
	{ 11, 27 }, /*  2: 2    */
	{  9, 26 }, /*  3: _[W */
	{ 11, 27 }, /*  4: 0    */
	{ 11, 27 }, /*  5: 1    */
	{ 11, 27 }, /*  6: 2    */
	{ 11, 28 }, /*  7: UA0   */
	{ 11, 25 }, /*  8: UA1   */
	{ 23, 48 }, /*  9: UA2   */
	{ 22, 43 }, /* 10: UA3   */
	{  7, 37 }, /* 11: UA4   */
	{ 18, 25 }, /* 12: UB0   */
	{ 16, 23 }, /* 13: UB1   */
	{ 29, 25 }, /* 14: UB2   */
	{ 27, 28 }, /* 15: UB3   */
	{ 11, 28 }, /* 16: UB4   */
	/******** nNI ********/
	/*  */
	{ 17, 29 }, /*  0: _[W */
	{ 13, 31 }, /*  1: 0    */
	{ 11, 31 }, /*  2: 1    */
	{ 11, 31 }, /*  3: 2    */
	/* w */
	{ 10, 21 }, /*  0: _[W */
	{ 11, 31 }, /*  1: 0    */
	{ 11, 31 }, /*  2: 1    */
	{ 14, 31 }, /*  3: 2    */
	/******** GD ********/
	/*  */
	{ 20, 29 }, /*  0: _[W */
	{ 13, 29 }, /*  1: 0    */
	{ 16, 29 }, /*  2: 1    */
	{ 20, 29 }, /*  3: 2    */
	/* w */
	{  9, 29 }, /*  0: _[W */
	{  8, 29 }, /*  1: 0    */
	{  7, 29 }, /*  2: 1    */
	{  7, 29 }, /*  3: 2    */
};

/****************************************************************************
 *	Aj[Vp^[`
 ****************************************************************************/

static short nuwf_stand[] = {
	CHIP_NUWF + 0,
	CHIP_NUWF + 1,
	CHIP_NUWF + 2,
	CHIP_NUWF + 1,
};
static short nuwf_damage[] = {
	CHIP_NUWF + 3,
};
static short nuwf_run[] = {
	CHIP_NUWF + 4,
	CHIP_NUWF + 5,
	CHIP_NUWF + 4,
	CHIP_NUWF + 6,
};
static short nuwf_attack1[] = {
	CHIP_NUWF + 7,
	CHIP_NUWF + 8,
	CHIP_NUWF + 9,
	CHIP_NUWF + 10,
	CHIP_NUWF + 11,
};
static short nuwf_attack2[] = {
	CHIP_NUWF + 12,
	CHIP_NUWF + 13,
	CHIP_NUWF + 14,
	CHIP_NUWF + 15,
	CHIP_NUWF + 16,
};
static short nuwr_stand[] = {
	CHIP_NUWR + 0,
	CHIP_NUWR + 1,
	CHIP_NUWR + 2,
	CHIP_NUWR + 1,
};
static short nuwr_damage[] = {
	CHIP_NUWR + 3,
};
static short nuwr_run[] = {
	CHIP_NUWR + 4,
	CHIP_NUWR + 5,
	CHIP_NUWR + 4,
	CHIP_NUWR + 6,
};
static short nuwr_attack1[] = {
	CHIP_NUWR + 7,
	CHIP_NUWR + 8,
	CHIP_NUWR + 9,
	CHIP_NUWR + 10,
	CHIP_NUWR + 11,
};
static short nuwr_attack2[] = {
	CHIP_NUWR + 12,
	CHIP_NUWR + 13,
	CHIP_NUWR + 14,
	CHIP_NUWR + 15,
	CHIP_NUWR + 16,
};
static short hakf_damage[] = {
	CHIP_HAKF + 0,
};
static short hakf_run[] = {
	CHIP_HAKF + 1,
	CHIP_HAKF + 2,
	CHIP_HAKF + 3,
	CHIP_HAKF + 2,
};
static short hakr_damage[] = {
	CHIP_HAKR + 0,
};
static short hakr_run[] = {
	CHIP_HAKR + 1,
	CHIP_HAKR + 2,
	CHIP_HAKR + 3,
	CHIP_HAKR + 2,
};
static short eruf_damage[] = {
	CHIP_ERUF + 0,
};
static short eruf_run[] = {
	CHIP_ERUF + 1,
	CHIP_ERUF + 2,
	CHIP_ERUF + 3,
	CHIP_ERUF + 2,
};
static short erur_damage[] = {
	CHIP_ERUR + 0,
};
static short erur_run[] = {
	CHIP_ERUR + 1,
	CHIP_ERUR + 2,
	CHIP_ERUR + 3,
	CHIP_ERUR + 2,
};

#define A(c, s)	{ s, sizeof (c) / sizeof *(c), c }
ANM anms[N_ANMS] = {
	A(nuwf_stand,   5),	/* ANM_NUWF_STAND   */
	A(nuwf_damage,  5),	/* ANM_NUWF_DAMAGE  */
	A(nuwf_run,     4),	/* ANM_NUWF_RUN     */
	A(nuwf_attack1, 2),	/* ANM_NUWF_ATTACK1 */
	A(nuwf_attack2, 2),	/* ANM_NUWF_ATTACK2 */
	A(nuwr_stand,   5),	/* ANM_NUWR_STAND   */
	A(nuwr_damage,  5),	/* ANM_NUWR_DAMAGE  */
	A(nuwr_run,     4),	/* ANM_NUWR_RUN     */
	A(nuwr_attack1, 2),	/* ANM_NUWR_ATTACK1 */
	A(nuwr_attack2, 2),	/* ANM_NUWR_ATTACK2 */
	A(hakf_damage,  5),	/* ANM_HAKF_DAMAGE  */
	A(hakf_run,     4),	/* ANM_HAKF_RUN     */
	A(hakr_damage,  5),	/* ANM_HAKR_DAMAGE  */
	A(hakr_run,     4),	/* ANM_HAKR_RUN     */
	A(eruf_damage,  5),	/* ANM_ERUF_DAMAGE  */
	A(eruf_run,     4),	/* ANM_ERUF_RUN     */
	A(erur_damage,  5),	/* ANM_ERUR_DAMAGE  */
	A(erur_run,     4),	/* ANM_ERUR_RUN     */
};
#undef A
