/*
 *	demo.c
 *
 *	ʂ
 *	Copyright (C) 2001-2002 Naoyuki Sawa
 *
 *	* Wed Jun  5 12:30:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

static void spline_seg(short t, short div, short x0, short y0, short x1, short y1, short x2, short y2,short x3, short y3, int color);

/****************************************************************************
 *	^Cgʃf[^
 ****************************************************************************/

static TCOORD nu1[] = {{13,21},{17,41},{22,51}};
static TCOORD nu2[] = {{21,20},{21,40},{15,51},{9,40},{18,27},{33,28},{36,44},{29,48},{25,39},{36,40},{43,50}};
static TCOORD wa1[] = {{44,8},{50,43},{50,55}};
static TCOORD wa2[] = {{41,26},{45,44},{53,23},{60,22},{61,37},{54,47}};
static TCOORD nn1[] = {{71,20},{67,46},{72,36},{77,37},{80,45},{85,45},{87,34}};
static TCOORD gi1[] = {{90,20},{98,19},{104,18}};
static TCOORD gi2[] = {{92,26},{99,26},{104,24}};
static TCOORD gi3[] = {{96,13},{99,32},{104,37},{94,35},{93,43},{100,49},{111,52}};
static TCOORD gi4[] = {{106,10},{110,18}};
static TCOORD gi5[] = {{112,8},{116,16}};
typedef struct _LINE {
	int n;
	TCOORD* c;
} LINE;
#define A(c)	{ sizeof (c) / sizeof *(c), c }
static LINE lines[] = {
	A(nu1),
	A(nu2),
	A(wa1),
	A(wa2),
	A(nn1),
	A(gi1),
	A(gi2),
	A(gi3),
	A(gi4),
	A(gi5),
};
#define N_LINES	(sizeof lines / sizeof *lines)
#define N_SEGS	3

/****************************************************************************
 *	demo
 ****************************************************************************/

int
demo()
{
	int result, i_line, i_coord, i_seg, i, j, n;
	short x0, y0, x1, y1, x2, y2, x3, y3;
	LINE* line;

	unsigned char *p, c;
	int dir, x, y;

	/* ŏɉʃNAAȍ~̓NA܂B */
	surface_clear(&surface, 0);

	/* tHgݒB */
	pceFontSetType(0x80);
	pceFontSetTxColor(2);
	pceFontSetBkColor(-1);

	/* _\B */
	pceFontSetPos(0, 0);
	pceFontPrintf("_ %05d00", score);

	/* vvg\B */
	pceFontSetPos((128 - 5 * 15) / 2, 64);
	pceFontPutStr("`{:퓬Jn");
	pceFontSetPos((128 - 5 * 15) / 2, 74);
	pceFontPutStr("SELECT:I@@");

	/* ^Cg\B */
	i_line = 0;	/* ŏ̃C                 */
	i_coord = 0;	/* ŏ̒_                   */
	i_seg = 0;	/* ŏ̃ZOgB         */
	dir = 0;	/* ɂݕ                     */
	i = 8;		/* ^Cg`Jn܂ł̃EFCg */
	for(;;) {
		schedule();

		/* L[B */
		if(pad & TRG_A) {
			result = 1; /* 퓬Jn */
			break;
		}
		if(pad & TRG_SELECT) {
			result = 0; /* I */
			break;
		}

		if(i == 0) {
			/* ܂`IĂȂ... */
			if(i_line < N_LINES) {
				line = &lines[i_line];
				n = line->n; /* _ */
				/* ̐__B */
				x1 = line->c[i_coord    ].s;
				y1 = line->c[i_coord    ].t;
				x2 = line->c[i_coord + 1].s;
				y2 = line->c[i_coord + 1].t;
				/* O̐__B */
				if(i_coord > 0) {
					x0 = line->c[i_coord - 1].s;
					y0 = line->c[i_coord - 1].t;
				} else { /* n_Ȃ΂łグ */
					x0 = x1 + (x1 - x2) * 2;
					y0 = y1 + (y1 - y2) * 2;
				}
				if(i_coord < n - 2) {
					x3 = line->c[i_coord + 2].s;
					y3 = line->c[i_coord + 2].t;
				} else { /* I_Ȃ΂łグ */
					x3 = x2 + (x2 - x1) * 2;
					y3 = y2 + (y2 - y1) * 2;
				}
				/* XvC̈ꕔ`܂B */
				spline_seg(i_seg, N_SEGS, x0, y0, x1, y1, x2, y2, x3, y3, 3);

				/* ̕ցB */
				i_seg++;
				if(i_seg == N_SEGS) {
					i_seg = 0;
					/* ̕ӂցB */
					i_coord++;
					if(i_coord == n - 1) { /* ӂȂ̂Œ_-1Ŕr */
						i_coord = 0;
						/* ̃CցB */
						i_line++;
					}
				}
			}
		} else {
			i--;
		}

		/* ɂݏB */
		switch(dir) {
		case 0: /*  */
			p = vbuff + sizeof vbuff - 1;
			for(y = DISP_Y - 1; y >= 1; y--) {
				for(x = DISP_X - 1; x >= 0; x--) {
					c = *(p - DISP_X);
					if(c != 0) {
						c--;
						if(*p < c) *p = c;
					}
					p--;
				}
			}
			break;
		case 1: /* E */
			p = vbuff + sizeof vbuff - 1;
			for(y = DISP_Y - 1; y >= 0; y--) {
				for(x = DISP_X - 1; x >= 1; x--) {
					c = *(p - 1);
					if(c != 0) {
						c--;
						if(*p < c) *p = c;
					}
					p--;
				}
				p--;
			}
			break;
		case 2: /*  */
			p = vbuff;
			for(y = 0; y < DISP_Y - 1; y++) {
				for(x = 0; x < DISP_X; x++) {
					c = *(p + DISP_X);
					if(c != 0) {
						c--;
						if(*p < c) *p = c;
					}
					p++;
				}
			}
			break;
		case 3: /*  */
			p = vbuff;
			for(y = 0; y < DISP_Y; y++) {
				for(x = 0; x < DISP_X - 1; x++) {
					c = *(p + 1);
					if(c != 0) {
						c--;
						if(*p < c) *p = c;
					}
					p++;
				}
				p++;
			}
			break;
		}
		dir = (dir + 1) % 4; /* ɂݕύX */
	}

	/* tF[hAEgB */
	for(i = 0; i < 4; i++) {
		for(j = 0; j < 3; j++) schedule();

		p = vbuff;
		for(y = 0; y < DISP_Y; y++) {
			for(x = 0; x < DISP_X; x++) {
				c = *p;
				if(c != 0) {
					c--;
					*p = c;
				}
				p++;
			}
		}
	}
	for(i = 0; i < 8; i++) schedule();

	return result;
}

/****************************************************************************
 *	spline_seg
 ****************************************************************************/

static void
spline_seg(short t, short div, short x0, short y0, short x1, short y1, short x2, short y2,short x3, short y3, int color)
{
	float t1, t2;
	short vx1, vy1, vx2, vy2;
	short dx1, dy1, dx2, dy2;

	t1 = (float) t      / div;
	t2 = (float)(t + 1) / div;

	vx1 = (x2 - x0) / 2;
	vy1 = (y2 - y0) / 2;
	vx2 = (x3 - x1) / 2;
	vy2 = (y3 - y1) / 2;

	dx1 = hermite1(t1, x1, x2, vx1, vx2);
	dy1 = hermite1(t1, y1, y2, vy1, vy2);
	dx2 = hermite1(t2, x1, x2, vx1, vx2);
	dy2 = hermite1(t2, y1, y2, vy1, vy2);

	render_line(&render, dx1, dy1, dx2, dy2, color);
}
